<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Panel.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Panel.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'uweaver/lang',
    'uweaver/widget/Container', 'uweaver/widget/Interact',
    'text!./tpl/Panel.html',
    'uweaver/Logger'], function(_, $, lang, Container, Interact, tpl, Logger) {

    var declare = lang.declare;
    var Base = Container;

    /**
     * **Panel**
     * A panel is a movable &amp; draggable container.
     *
     * **Configs:**
     * - tpl(String): A html string to layout &amp; construct the DOM.
     * - title(String): The title of the panel.
     * - collapsible(Boolean): Specify if the panel is collapsible.
     *
     * @constructor Panel
     * @extends Container
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - The configuration of the panel.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {
            title: undefined,
            collapsible: false,
            tpl: tpl
        };
        var cfg = this.cfg();

        _.defaults(cfg, defaults);

        this._anchors = {
            $header: undefined,
            $content: undefined,
            $title: undefined
        };

        this._movement = {x:0, y:0};
        this.title(cfg.title);

        if(this.css('position')==='static' || this.css('position')==='') {
            this.css('position', 'fixed');
        }

        this.$el.on('click', _.bind(onFocus, this));
    }

    /**
     * @memberof Panel#
     * @protected
     */
    function render(options) {
        Base.prototype.render.apply(this, arguments);

        var defaults = {
            hidden: false
        };
        options || (options = {});
        _.defaults(options, defaults);

        var cfg = this.cfg();
        var anchors = this._anchors;

        anchors.$header = this.$anchor("header");
        anchors.$content = this.$anchor("content");
        anchors.$title = anchors.$header.find('[data-uw-anchor=title]');

        anchors.$title.html(this.title());

        if(cfg.collapsible) {
            anchors.$header.on('click', _.bind(this.toggle, this));
        }

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;

    }

    /**
     * Get or set the title of the panel.
     *
     * ##### Events:
     * - 'transition:title' => triggered after title changed. event.data => the title.
     *
     * @memberof Panel#
     * @param {String} [text] - the title.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * ##### Options:
     * + silent(Boolean) - A false value will prevent the events from being triggered. Default: false.
     * @returns {String}
     */
    function title(html, options) {
        if(arguments.length===0) return this._title;

        options || (options = {});

        this._title = html;

        this._anchors.$title &amp;&amp; this._anchors.$title.html(html);

        options.silent || this.trigger('transition:title', {
            context: this,
            source: this,
            data: this._title
        });
    }

    /**
     * Get or set the badge of the panel.
     *
     * ##### Events:
     * - 'transition:badge' => triggered after badge changed. event.data => the badge.
     *
     * @memberof Panel#
     * @param {String} [text] - the badge.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * ##### Options:
     * + silent(Boolean) - A false value will prevent the events from being triggered. Default: false.
     * @returns {String}
     */
    function badge(text, options) {
        if(!text) return this._badge;

        options || (options = {});

        this._badge = text;
        options.silent || this.trigger('transition:badge', {
            context: this,
            source: this,
            data: this._badge
        });
    }

    /**
     *
     * Get or set the menu.
     *
     * ##### Events:
     * - 'transition:menu' => triggered after menu changed. event.data => the menu.
     *
     * @memberof Panel#
     * @param {Triggers} triggers - the menu.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * ##### Options:
     * + silent(Boolean) - A false value will prevent the events from being triggered. Default: false.
     * @returns {Triggers}
     *
     */
    function menu(triggers, options) {
        if(!triggers) return this._menu;

        options || (options = {});

        this._menu = triggers;
        options.silent || this.trigger('transition:menu', {
            context: this,
            source: this,
            data: this._menu
        });
    }

    function enable() {
        this.removeClass("uw-disable");
    }

    function disable() {
        this.addClass("uw-disable");
    }

    function collapse() {
        this._anchors.$content.hide();
    }

    function expand() {
        this._anchors.$content.show();
    }

    function isCollapsed() {
        return (this._anchors.$content.css("display")==='none');
    }

    function toggle() {
        this.isCollapsed() ? this.expand() : this.collapse();
    }

    function movable(options) {
        options || (options = {});

        var defaults = {
            inertia: false
        };

        options = _.defaults(options, defaults);

        options.restrict || (options.restrict = {});

        options.restrict = _.defaults(options.restrict, {
            restriction: this.$el.parent(),
            endOnly: true,
            elementRect: { top: 0, left: 0, bottom: 1, right: 1 }
        });

        if(this._anchors.$header.length>0) {
            var mover = new Interact({
                el: this._anchors.$header
            });
            mover.render();

            this.listenTo(mover, 'dragmove', _.bind(onDragmove, this));
            this._mover = mover;

            mover.addClass("uw-movable");

            mover.draggable(options);

            mover.show();
            //this._anchors.$header.off('click');
        }
    }

    function resizable(options) {
        var resizer = new Interact({
            el: this.$el
        });
        resizer.render();
        this.listenTo(resizer, 'resizemove', _.bind(onResizemove, this));
        this._resizer = resizer;

        resizer.resizable({
            edges: { left: true, right: true, bottom: true, top: true }
        });
    }

    function onDragmove(event) {
        var movement = this._movement;
        var x = movement.x + event.data.dx;
        var y = movement.y + event.data.dy;


        this.el.style.webkitTransform =
            this.el.style.transform = 'translate(' + x + 'px, ' + y + 'px)';

        movement.x = x;
        movement.y = y;
    }

    function onResizemove(event) {
        var anchors = this._anchors;
        var movement = this._movement;

        var width = this.$el.width() + event.data.dRect.width;
        var height = anchors.$content.height() + event.data.dRect.height;

        // update the element's style
        this.$el.width(width);
        anchors.$content.height(height);

        // prevent child elements from overflow
        if(anchors.$content.get(0).offsetHeight &lt; anchors.$content.get(0).scrollHeight) {
            anchors.$content.height(anchors.$content.get(0).scrollHeight);
        }

        // translate when resizing from top or left edges
        var x = movement.x + event.data.dRect.left;
        var y = movement.y + event.data.dRect.top;

        this.el.style.webkitTransform =
            this.el.style.transform = 'translate(' + x + 'px, ' + y + 'px)';

        this.el.style.webkitTransform = this.el.style.transform =
            'translate(' + x + 'px,' + y + 'px)';

        movement.x = x;
        movement.y = y;
    }

    function onFocus(event) {
        this.focus();
    }

    function focus() {
        var event = {
            context: this,
            source: this,
            data: {}
        };

        this._anchors.$header.css('opacity', 1);
        this.trigger('focus', event);
    }

    function blur() {
        var event = {
            context: this,
            source: this,
            data: {}
        };

        this._anchors.$header.css('opacity', 0.7);
        this.trigger('blur', event);
    }

    function show() {
        Base.prototype.show.apply(this, arguments);
        this.focus();
    }

    var props = {
        LOGGER: new Logger("Panel"),

        _mover: undefined,
        _resizer: undefined,
        _movement: undefined,
        _title: undefined
    };

    var Panel = declare(Base, {

        initialize: initialize,
        render: render,

        title: title,
        collapse: collapse,
        expand: expand,
        isCollapsed: isCollapsed,
        toggle: toggle,
        close: close,
        enable: enable,
        disable: disable,
        draggable: movable,
        movable: movable,
        resizable: resizable,
        badge: badge,
        show: show,
        menu: menu,
        focus: focus,
        blur: blur
    }, props);


    return Panel;
});
</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
